# Generated by Django 3.2.12 on 2022-02-05 11:45

from django.db import migrations, models
import django.db.models.deletion

import aleksis.core.managers


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('core', '0035_preference_model_unique'),
        ('chronos', '0010_remove_subject_unique_name_per_site'),
    ]

    run_before = [
        ('core', '0047_add_room_model'),
    ]

    operations = [
        migrations.CreateModel(
            name='SeatingPlan',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('extended_data', models.JSONField(default=dict, editable=False)),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.group', verbose_name='Group')),
                ('room', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='chronos.room', verbose_name='Room')),
                ('subject', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='chronos.subject', verbose_name='Subject')),
            ],
            options={
                'verbose_name': 'Seating plan',
                'verbose_name_plural': 'Seating plans',
            },
            managers=[
                ('objects', aleksis.core.managers.AlekSISBaseManager()),
            ],
        ),
        migrations.CreateModel(
            name='Seat',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('extended_data', models.JSONField(default=dict, editable=False)),
                ('x', models.PositiveIntegerField(verbose_name='X position')),
                ('y', models.PositiveIntegerField(verbose_name='Y position')),
                ('person', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.person', verbose_name='Person')),
                ('plan', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='stoelindeling.seatingplan', verbose_name='Seating plan')),
            ],
            options={
                'verbose_name': 'Seat',
                'verbose_name_plural': 'Seats',
            },
            managers=[
                ('objects', aleksis.core.managers.AlekSISBaseManager()),
            ],
        ),
        migrations.AddConstraint(
            model_name='seatingplan',
            constraint=models.UniqueConstraint(fields=('group', 'subject', 'room'), name='unique_group_subject_room'),
        ),
        migrations.AddConstraint(
            model_name='seat',
            constraint=models.UniqueConstraint(fields=('plan', 'person'), name='unique_plan_person'),
        ),
    ]
